/*
 * Licensed Materials - Use restricted. For use in compiling interfaces to
 * IBM Rational TestManager.
 * (c) Copyright IBM Corporation 2001,2002,2006.  All Rights Reserved.
 */

#include "stdafx.h"
#include "CustomScriptGeneratorAdapter.h"
#include "CustomConfigurationUI.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define RSR_EXT_STUB_SILENT "RSR_EXT_STUB_SILENT"

#include <iostream.h>
#include <fstream.h>
char buf;
CCustomConfigurationUI	dlgCustomConfiguration;

static TCHAR optionValues[RSR_MAX_OPTIONS];
BOOL ParseString(TCHAR SeedString[],TCHAR Delimiter, CStringArray* ReturnArray);

extern "C" 
BOOL LINKDLL IsCustomScriptgenAdapter()
{
   if(!GetEnvironmentVariable(RSR_EXT_STUB_SILENT,&buf,0))
		MessageBox(NULL, "IsCustomScriptgenAdapter: TRUE",
                       "Hello from Custom Script Generator Adapter Stub!", MB_OK);
    return TRUE; 
}

extern "C"
int LINKDLL GetDisplayName(TCHAR* name, 
                           size_t nameSize)
{
    _tcscpy(name, "Custom Script Generator Adapter#1");
    return RSR_SUCCESS;
} 

extern "C" 
int LINKDLL GetOptions(TCHAR* options, 
                       size_t optionsSize)
{
    _tcscpy(options, _T(""));

    TCHAR opVar[4096];    

    if (::GetEnvironmentVariable(_T("RSR_CUST_SGEN_OPTIONS"), opVar, 4096) != 0)
    {    
        _tcscpy(options, opVar);
        return RSR_SUCCESS;
    }

    _tcscat(options, "option1;option2");
    
    if(!GetEnvironmentVariable(RSR_EXT_STUB_SILENT,&buf,0))
	{
		MessageBox(NULL, "GetOptions: ",
                       "Hello from Custom Script Generator Adapter Stub!", MB_OK);
		MessageBox(NULL, options,
                       "Hello from Custom Script Generator Adapter Stub!", MB_OK);
	}
    if (_tcslen(options)+1 > optionsSize)
        return RSR_BUFFER_TOO_SHORT;
    else
        return RSR_SUCCESS;
}


extern "C" 
int LINKDLL SetOptions(TCHAR *options, 
                       size_t optionsSize,
                       TCHAR* errorMessage,
                       size_t errorMessageSize)
{
    if (optionsSize > RSR_MAX_OPTIONS)
        return RSR_BUFFER_TOO_SHORT;
    _tcscpy(optionValues, options);
	if(!GetEnvironmentVariable(RSR_EXT_STUB_SILENT,&buf,0))
    {
		MessageBox(NULL, options,
                       "Custom Script Generator SetOptions", MB_OK);
	}
    return RSR_SUCCESS;
}

extern "C" 
int LINKDLL DisplayCustomConfigGUI(TCHAR* errorMessage, 
                                   size_t errorMessageSize)
{
   AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	if(!dlgCustomConfiguration.m_hWnd)
	{
		dlgCustomConfiguration.Create(IDD_CUSTOM_CONFIGURATION_GUI);
		dlgCustomConfiguration.ShowWindow(SW_SHOW);
	}
	else if(!dlgCustomConfiguration.IsWindowVisible())
		dlgCustomConfiguration.ShowWindow(SW_SHOW);
	else
		dlgCustomConfiguration.BringWindowToTop();

	
	return RSR_SUCCESS;
} 

extern "C" 
int LINKDLL InitializeScriptgen(TCHAR* errorMessage, 
                                size_t errorMessageSize)
{
    if(!GetEnvironmentVariable(RSR_EXT_STUB_SILENT,&buf,0))
		MessageBox(NULL, "Initialize Script Generation",
                       "Hello from Custom Script Generator Adapter Stub!", MB_OK);
    return RSR_SUCCESS;
} 


extern "C" 
int LINKDLL StartScriptgen(TCHAR* pathname,
                           size_t pathnameSize,
                           TCHAR* scriptFilePathnames, 
                           size_t scriptFilePathnamesSize,
                           StatusCallbackPtr fPtr,
                           TCHAR* errorMessage,
                           size_t errorMessageSize)
{
    
 
	CStringArray ScriptNames;

	for (int i=1; i<=10; i++)
    {
        TCHAR progress[5];
		sprintf(progress,"%d",i*10);
		fPtr(RSR_CALLBACK_PROGRESS, progress);
		Sleep(1000);
	/*	if(i==2)
		{
			
			TCHAR message[MAX_PATH];
			sprintf(message,"Script Generator Error...");
			fPtr(RSR_CALLBACK_ERROR, message);
			return RSR_SUCCESS;
		}*/

    }
	
	
	ParseString(scriptFilePathnames,';',&ScriptNames);
	
	
	for(i = 0;i<ScriptNames.GetSize();i++)
	{
		CopyFile("c:\\seed.java",ScriptNames[i]+".java",FALSE);
		TCHAR message[269];
		sprintf(message,"Successfully created script %s.java",ScriptNames[i]);
		fPtr(RSR_CALLBACK_DETAILS, message);
	}
    
	fPtr(RSR_CALLBACK_FINISHED, "Script Generation Completed Successfully!!!");
    
    return RSR_SUCCESS;
}


extern "C" 
int LINKDLL CancelScriptgen(TCHAR* errorMessage, size_t errorMessageSize)
{
    if(!GetEnvironmentVariable(RSR_EXT_STUB_SILENT,&buf,0))
		MessageBox(NULL, "Cancel Script Generation",
                       "Hello from Custom Script Generator Adapter Stub!", MB_OK);
    return RSR_SUCCESS;
}


///////////////////////////////////////////////////////////////////////////////
//ParseString
//this routine parses a TCHAR and returns the results as a CString Array
BOOL ParseString(TCHAR SeedString[],TCHAR Delimiter, CStringArray* ReturnArray)
{
	
	CString buf = SeedString;
	if(buf.GetLength()==0)
		return FALSE;

	while(buf.Find(Delimiter)>=0)
	{
		CString Entry = buf.Left(buf.Find(Delimiter));
		Entry.TrimLeft();
		Entry.TrimRight();
		ReturnArray->Add(Entry);
		buf = buf.Right(buf.GetLength()-buf.Find(Delimiter)-1);
		
	}

	buf.TrimLeft();
	buf.TrimRight();
	ReturnArray->Add(buf);
	
	return TRUE;


}
